com.io7m.r2.core.debug

## Class R2DebugCubeInstance

- java.lang.Object
- - com.io7m.r2.core.debug.R2DebugCubeInstance

- All Implemented Interfaces:
    R2DebugCubeInstanceType

      @Generated(value={"Immutables.generator","R2DebugCubeInstanceType"})
      public final class R2DebugCubeInstance
      extends Object
      implements R2DebugCubeInstanceType

  A cube.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2DebugCubeInstance.Builder` Builds instances of type `R2DebugCubeInstance`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static R2DebugCubeInstance.Builder` | `builder()` Creates a builder for `R2DebugCubeInstance`.
    `com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType>` | `color()`
    `static R2DebugCubeInstance` | `copyOf(R2DebugCubeInstanceType instance)` Creates an immutable copy of a `R2DebugCubeInstanceType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2DebugCubeInstance` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `transform`, `color`.
    `static R2DebugCubeInstance` | `of(R2TransformReadableType transform, com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> color)` Construct a new immutable `R2DebugCubeInstance` instance.
    `String` | `toString()` Prints the immutable value `R2DebugCubeInstance` with attribute values.
    `R2TransformReadableType` | `transform()`
    `R2DebugCubeInstance` | `withColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)` Copy the current immutable object by setting a value for the `color` attribute.
    `R2DebugCubeInstance` | `withTransform(R2TransformReadableType value)` Copy the current immutable object by setting a value for the `transform` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### transform

          public R2TransformReadableType transform()

      Specified by:
        `transform` in interface `R2DebugCubeInstanceType`
      Returns:
        The transform applied to the center of the cube

    - #### color

          public com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> color()

      Specified by:
        `color` in interface `R2DebugCubeInstanceType`
      Returns:
        The color of the cube

    - #### withTransform

          public final R2DebugCubeInstance withTransform(R2TransformReadableType value)

      Copy the current immutable object by setting a value for the `transform` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for transform
      Returns:
        A modified copy of the `this` object

    - #### withColor

          public final R2DebugCubeInstance withColor(com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> value)

      Copy the current immutable object by setting a value for the `color` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for color
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2DebugCubeInstance` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `transform`, `color`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2DebugCubeInstance` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2DebugCubeInstance of(R2TransformReadableType transform,
                                               com.io7m.jtensors.parameterized.PVectorI4F<R2SpaceRGBAType> color)

      Construct a new immutable `R2DebugCubeInstance` instance.
      Parameters:
        `transform` - The value for the `transform` attribute
        `color` - The value for the `color` attribute
      Returns:
        An immutable R2DebugCubeInstance instance

    - #### copyOf

          public static R2DebugCubeInstance copyOf(R2DebugCubeInstanceType instance)

      Creates an immutable copy of a `R2DebugCubeInstanceType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2DebugCubeInstance instance

    - #### builder

          public static R2DebugCubeInstance.Builder builder()

      Creates a builder for `R2DebugCubeInstance`.
      Returns:
        A new R2DebugCubeInstance builder

Copyright © 2017 <code@io7m.com> http://io7m.com